/*
 Made by - Abishkrit Nandan Boruah
 Started at - 27/4/20

 The code can be quite primitive cause i had almost no knowledge making C application while making this
 So if you want to improve any part you are welcome to!!
 
 Note for this version: This version tries to add new functionalities and changes some aspect of story telling and fixes some 
 issues

*/

#include <stdio.h>
#include <string.h>
#include <conio.h>

//Initialize
void print_help(), check_input(), look(), no_move(), move_north(), look_bathroom(), move_south(), move_west(), look_bedroom(), move_east();
void no_take(), take(), no_take(), take_bathroom(), take_bedroom(), unlock(), unlockit(), no_unlock(), inventory();

//Constants
const char intro[] = "//Adventure Game V1.1//\nby - Abishkrit Nandan Boruah(INTFORTS)\nuse HELP for instruction\n------\n";
const char story[] = "Like everyday me and my friends were out playing\nbut today was special, today was bravery day where\nwe all go to a certain haunted place one by one\nand stay there for about ten minutes and then\nreturn back.Today we are going to Mr Rolly's\nhome, one of the most haunted place in the town.\nit is my turn first, as I enter the house the\ndoor suddenly closes and all my friends run away\nI look back and see a padlock.\nI need to find a key and get out of here!!\n------\n";
const char help[] = "------\nThe instruction -\nall input should be capital \n UNLOCK - unlock the lock LOOK - print the decriptions of the surrounding\n NORTH - move up north\n SOUTH - move up south\n EAST - move up east\n WEST - move up west\n TAKE - take the object\n INVENTORY - check your inventory\n------\n";
const char hall_look[] = "------\nThe Hall - \nA hall with a table on the middle and two doors\nin front, ohhh also a padlock in the door.\n------\n";
const char bed_look1[] = "------\nThe Bedroom -\nThere is not much to see here just a bed and \na small cabinet near it with  a candle on the top.\n------\n";
const char bed_look2[] = "------\nThe Bedroom -\nThere is not much to see here just a bed.\n------\n";
const char kitchen_look[] = "------\nThe Kitchen - \nNothing interesting here but there is a broken\ndoor towards west.\n------\n";
const char bathroom_look1[] = "------\nThe Bathroom -\nCan't see anything it is so dark.If only I had a candle\n------\n";
const char bathroom_look2[] = "------\nThe Bathroom -\nI light the candle. There is a small key in the ground.\n------\n";

//Variables
int has_key = 0;     //does the player have the key?? 0 = false, 1 = true
int has_candle = 0;  //does the player have the candle?? 0 = false, 1 = true
char input[60];      //stores the input from the player
int over = 0;        //is the game over?? 0 = false, 1 = true
int where = 0;       //where is the player currentlly?? 0 = hall(default), 1 = kitchen, 2 = bedroom, 3 = bathroom

//The program
int main() {
	if (con_init_console_dll()) return 1; // init fail
    con_set_title("Adventure Game v1.1");
    
	printf("%s", intro);
	printf("%s", story);
	printf("%s", hall_look);
	check_input();
	return 0;
	}

//Prints the help
void print_help() {
	printf("%s", help);
	}

//Checks for users input and reacts
void check_input() {
	//keeps checking for input untill the game is over
	while (over == 0) {
		printf(">>");
		scanf("%s", &input);

		if (strstr(input, "HELP")) {
			print_help();
			}

		else if (strstr(input, "LOOK")) {
			//checks which room the player is in
			switch(where) {
				case 0:
					printf("%s", hall_look);
					break;
				case 1:
					printf("%s", kitchen_look);
					break;
				case 2:
					look_bedroom();
				case 3:
					look_bathroom();
				}
			}
		else if (strstr(input, "NORTH")){
			move_north();
			}

		else if (strstr(input, "SOUTH")){
			move_south();
			}

		else if (strstr(input, "WEST")){
			move_west();
			}

		else if (strstr(input, "EAST")){
			move_east();
			}

		else if (strstr(input, "TAKE")){
			take();
			}

		else if (strstr(input, "UNLOCK")){
			unlock();
			}

		else if (strstr(input, "INVENTORY")){
			inventory();
			}
			
		else {
			printf("hmmm?? said something??\n");
			}
		}
	printf("You won!! The end");
	con_exit(1);
	}

//Function to move North
void move_north(){
	switch(where){
		case 0:
			where = 1;
			printf("%s", kitchen_look);
			break;
		default:
			no_move();
		}
	}

//Function used to move South
void move_south(){
	switch(where){
		case 1:
			where = 0;
			printf("%s", hall_look);
			break;
		case 2:
			where = 0;
			printf("%s", hall_look);
			break;
		default:
			no_move();
		}
	}

//Function used to move South
void move_west(){
	switch(where){
		case 0:
			where = 2;
			look_bedroom();
			break;
		case 1:
			where = 3;
			look_bathroom();
			break;
		default:
			no_move();
		}
	}

//Function used to move South
void move_east(){
	switch(where){
		case 3:
			where = 1;
			printf("%s", kitchen_look);
			break;

		default:
			no_move();
		}
	}



//Called when can't go the direction provided
void no_move() {
	printf("Well can't go that way\n");
	}

void look_bathroom(){
	if (has_candle == 1){
		printf("%s", bathroom_look2);
		}
	else {
		printf("%s", bathroom_look1);
		}
	}

void look_bedroom(){
	if (has_key == 1){
		printf("%s", bed_look2);
		}
	else {
		printf("%s", bed_look1);
		}
	}

void take() {
	switch(where){
		case 2:
			take_bedroom();
			break;
		case 3:
			take_bathroom();
			break;
		default:
			no_take();
		}
	}

void no_take() {
	printf("Nothing to take from here\n");
	}

void take_bathroom() {
	if (has_candle) {
		has_key = 1;
		printf("KEY is taken\n");
		}
	else {
		no_take();
		}
	}
void take_bedroom() {
	if (has_candle == 0) {
		has_candle = 1;
		printf("CANDLE is taken\n");
		}
	else {
		no_take();
		}
	}

void unlock() {
	switch(where){
		case 0:
			unlockit();
			break;
		default:
			no_unlock;
		}
	}
void unlockit() {
	if (has_key == 1) {
	over = 1;
		}
	else {
		printf("You need a key to unlock the lock\n");
		}
	}

void no_unlock() {
	printf("Nothing to unlock here\n");
	}

void inventory() {
	printf("------\nINVENTORY:\n");
	if (has_key){
		printf("KEY\n");
		}
	if (has_candle){
		printf("CANDLE\n");
		}
	printf("------\n");
	}
